require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_vmnetworkadapterteammapping',
  dscmeta_resource_friendly_name: 'VMNetworkAdapterTeamMapping',
  dscmeta_resource_name: 'VMNetworkAdapterTeamMapping',
  dscmeta_resource_implementation: 'Class',
  dscmeta_module_name: 'VMNetworkAdapter',
  dscmeta_module_version: '0.4',
  docs: 'The DSC VMNetworkAdapterTeamMapping resource type.
         Automatically generated from version 0.4',
  features: ['simple_get_filter', 'canonicalize', 'custom_insync'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    validation_mode: {
      type:      'Enum[property, resource]',
      desc:      'Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode (resource).',
      behaviour: :parameter,
      default:   'property',
    },
    dsc_vmnetworkadaptername: {
      type: 'String',
      desc: ' ',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_physicalnetadaptername: {
      type: 'String',
      desc: ' ',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_ensure: {
      type: "Enum['Absent', 'Present']",
      desc: ' ',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
